1 # Test framework for git. See t/README for usage.
3 # Copyright (c) 2005 Junio C Hamano
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
13 # GNU General Public License for more details.
15 # You should have received a copy of the GNU General Public License
16 # along with this program. If not, see http://www.gnu.org/licenses/ .
18 # Keep the original TERM for say_color
21 # Test the binaries we have just built. The tests are kept in
22 # t/ subdirectory and are run in 'trash directory' subdirectory.
23 if test -z "$TEST_DIRECTORY"
25 # We allow tests to override this, in case they want to run tests
26 # outside of t/, e.g. for running tests on the test library
30 # ensure that TEST_DIRECTORY is an absolute path so that it
31 # is valid even if the current working directory is changed
32 TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1
34 if test -z "$TEST_OUTPUT_DIRECTORY"
36 # Similarly, override this to store the test-results subdir
38 TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY
40 GIT_BUILD_DIR="$TEST_DIRECTORY"/..
42 ################################################################
43 # It appears that people try to run tests without building...
44 "$GIT_BUILD_DIR/git" >/dev/null
47 echo >&2 'error: you do not seem to have built git yet.'
51 . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS
52 export PERL_PATH SHELL_PATH
54 # if --tee was passed, write the output not only to the terminal, but
55 # additionally to the file test-results/$BASENAME.out, too.
56 case "$GIT_TEST_TEE_STARTED, $* " in
58 # do not redirect again
60 *' --tee '*|*' --va'*)
61 mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results"
62 BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)"
63 (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1;
64 echo $? > $BASE.exit) | tee $BASE.out
65 test "$(cat $BASE.exit)" = 0
70 # For repeatability, reset the environment to known value.
76 export LANG LC_ALL PAGER TERM TZ
78 # A call to "unset" with no arguments causes at least Solaris 10
79 # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets
80 # deriving from the command substitution clustered with the other
82 unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e '
84 my $ok = join("|", qw(
95 my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env);
96 print join("\n", @vars);
100 GIT_AUTHOR_EMAIL=author@example.com
101 GIT_AUTHOR_NAME='A U Thor'
102 GIT_COMMITTER_EMAIL=committer@example.com
103 GIT_COMMITTER_NAME='C O Mitter'
104 GIT_MERGE_VERBOSITY=5
105 GIT_MERGE_AUTOEDIT=no
106 export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT
107 export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
108 export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
111 # Add libc MALLOC and MALLOC_PERTURB test
112 # only if we are not executing the test with valgrind
113 if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null ||
114 test -n "$TEST_NO_MALLOC_CHECK"
116 setup_malloc_check () {
119 teardown_malloc_check () {
123 setup_malloc_check () {
124 MALLOC_CHECK_=3 MALLOC_PERTURB_=165
125 export MALLOC_CHECK_ MALLOC_PERTURB_
127 teardown_malloc_check () {
128 unset MALLOC_CHECK_ MALLOC_PERTURB_
132 # Protect ourselves from common misconfiguration to export
133 # CDPATH into the environment
139 case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
141 echo "* warning: Some tests will not work if GIT_TRACE" \
142 "is set as to trace on STDERR ! *"
143 echo "* warning: Please set GIT_TRACE to something" \
144 "other than 1, 2 or true ! *"
150 # A regexp to match 5 and 40 hexdigits
151 _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]'
152 _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05"
155 _z40=0000000000000000000000000000000000000000
161 export _x05 _x40 _z40 LF
163 # Each test should start with something like this, after copyright notices:
165 # test_description='Description of this test...
166 # This test checks if command xyzzy does the right thing...
169 [ "x$ORIGINAL_TERM" != "xdumb" ] && (
170 TERM=$ORIGINAL_TERM &&
173 tput bold >/dev/null 2>&1 &&
174 tput setaf 1 >/dev/null 2>&1 &&
175 tput sgr0 >/dev/null 2>&1
179 while test "$#" -ne 0
182 -d|--d|--de|--deb|--debu|--debug)
184 -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
185 immediate=t; shift ;;
186 -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests)
187 GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;;
188 -h|--h|--he|--hel|--help)
190 -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
193 verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
195 -q|--q|--qu|--qui|--quie|--quiet)
196 # Ignore --quiet under a TAP::Harness. Saying how many tests
197 # passed without the ok/not ok details is always an error.
198 test -z "$HARNESS_ACTIVE" && quiet=t; shift ;;
200 with_dashes=t; shift ;;
203 --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind)
207 valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)')
210 valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)')
213 shift ;; # was handled already
215 root=$(expr "z$1" : 'z[^=]*=\(.*\)')
218 echo "error: unknown test option '$1'" >&2; exit 1 ;;
222 if test -n "$valgrind_only"
224 test -z "$valgrind" && valgrind=memcheck
225 test -z "$verbose" && verbose_only="$valgrind_only"
226 elif test -n "$valgrind"
239 tput bold; tput setaf 1;; # bold red
241 tput setaf 4;; # blue
243 tput setaf 3;; # brown/yellow
245 tput setaf 2;; # green
247 tput setaf 6;; # cyan
249 test -n "$quiet" && return;;
259 test -z "$1" && test -n "$quiet" && return
266 say_color error "error: $*"
275 test "${test_description}" != "" ||
276 error "Test script did not set test_description."
278 if test "$help" = "t"
280 printf '%s\n' "$test_description"
286 if test "$verbose" = "t"
290 exec 4>/dev/null 3>/dev/null
299 test_external_has_tap=0
303 if test -n "$GIT_EXIT_OK"
307 echo >&5 "FATAL: Unexpected exit with code $code"
315 # The user-facing functions are loaded from a separate file so that
316 # test_perf subshells can have them too
317 . "$TEST_DIRECTORY/test-lib-functions.sh"
319 # You are not expected to call test_ok_ and test_failure_ directly, use
320 # the test_expect_* functions instead.
323 test_success=$(($test_success + 1))
324 say_color "" "ok $test_count - $@"
328 test_failure=$(($test_failure + 1))
329 say_color error "not ok $test_count - $1"
331 printf '%s\n' "$*" | sed -e 's/^/# /'
332 test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
335 test_known_broken_ok_ () {
336 test_fixed=$(($test_fixed+1))
337 say_color error "ok $test_count - $@ # TODO known breakage vanished"
340 test_known_broken_failure_ () {
341 test_broken=$(($test_broken+1))
342 say_color warn "not ok $test_count - $@ # TODO known breakage"
346 test "$debug" = "" || eval "$1"
349 match_pattern_list () {
352 test -z "$*" && return 1
363 maybe_teardown_verbose () {
364 test -z "$verbose_only" && return
365 exec 4>/dev/null 3>/dev/null
370 maybe_setup_verbose () {
371 test -z "$verbose_only" && return
372 if match_pattern_list $test_count $verbose_only
375 # Emit a delimiting blank line when going from
376 # non-verbose to verbose. Within verbose mode the
377 # delimiter is printed by test_expect_*. The choice
378 # of the initial $last_verbose is such that before
379 # test 1, we do not print it.
380 test -z "$last_verbose" && echo >&3 ""
383 exec 4>/dev/null 3>/dev/null
386 last_verbose=$verbose
389 maybe_teardown_valgrind () {
390 test -z "$GIT_VALGRIND" && return
391 GIT_VALGRIND_ENABLED=
394 maybe_setup_valgrind () {
395 test -z "$GIT_VALGRIND" && return
396 if test -z "$valgrind_only"
398 GIT_VALGRIND_ENABLED=t
401 GIT_VALGRIND_ENABLED=
402 if match_pattern_list $test_count $valgrind_only
404 GIT_VALGRIND_ENABLED=t
409 # This is a separate function because some tests use
410 # "return" to end a test_expect_success block early.
411 eval </dev/null >&3 2>&4 "$*"
420 teardown_malloc_check
422 if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure"
425 test_eval_ "$test_cleanup"
426 teardown_malloc_check
428 if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE"
436 test_count=$(($test_count+1))
443 maybe_teardown_valgrind
444 maybe_teardown_verbose
449 if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS
453 if test -z "$to_skip" && test -n "$test_prereq" &&
454 ! test_have_prereq "$test_prereq"
461 if test "$missing_prereq" != "$test_prereq"
463 of_prereq=" of $test_prereq"
466 say_color skip >&3 "skipping test: $@"
467 say_color skip "ok $test_count # skip $1 (missing $missing_prereq${of_prereq})"
476 # stub; perf-lib overrides it
477 test_at_end_hook_ () {
484 if test -z "$HARNESS_ACTIVE"
486 test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results"
487 mkdir -p "$test_results_dir"
489 test_results_path="$test_results_dir/${base%.sh}-$$.counts"
491 cat >>"$test_results_path" <<-EOF
493 success $test_success
501 if test "$test_fixed" != 0
503 say_color error "# $test_fixed known breakage(s) vanished; please update test(s)"
505 if test "$test_broken" != 0
507 say_color warn "# still have $test_broken known breakage(s)"
509 if test "$test_broken" != 0 || test "$test_fixed" != 0
511 test_remaining=$(( $test_count - $test_broken - $test_fixed ))
512 msg="remaining $test_remaining test(s)"
514 test_remaining=$test_count
515 msg="$test_count test(s)"
517 case "$test_failure" in
519 # Maybe print SKIP message
520 if test -n "$skip_all" && test $test_count -gt 0
522 error "Can't use skip_all after running some tests"
524 [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all"
526 if test $test_external_has_tap -eq 0
528 if test $test_remaining -gt 0
530 say_color pass "# passed all $msg"
532 say "1..$test_count$skip_all"
535 test -d "$remove_trash" &&
536 cd "$(dirname "$remove_trash")" &&
537 rm -rf "$(basename "$remove_trash")"
544 if test $test_external_has_tap -eq 0
546 say_color error "# failed $test_failure among $msg"
555 if test -n "$valgrind"
559 test "$1" = "$(readlink "$2")" || {
567 while test -d "$2".lock
569 say "Waiting for lock on $2."
576 make_valgrind_symlink () {
577 # handle only executables, unless they are shell libraries that
578 # need to be in the exec-path.
580 test "# " = "$(head -c 2 <"$1")" ||
583 base=$(basename "$1")
584 symlink_target=$GIT_BUILD_DIR/$base
585 # do not override scripts
586 if test -x "$symlink_target" &&
587 test ! -d "$symlink_target" &&
588 test "#!" != "$(head -c 2 < "$symlink_target")"
590 symlink_target=../valgrind.sh
594 symlink_target=../unprocessed-script
596 # create the link, or replace it if it is out of date
597 make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit
600 # override all git executables in TEST_DIRECTORY/..
601 GIT_VALGRIND=$TEST_DIRECTORY/valgrind
602 mkdir -p "$GIT_VALGRIND"/bin
603 for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-*
605 make_valgrind_symlink $file
607 # special-case the mergetools loadables
608 make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools"
613 ls "$path"/git-* 2> /dev/null |
616 make_valgrind_symlink "$file"
620 PATH=$GIT_VALGRIND/bin:$PATH
621 GIT_EXEC_PATH=$GIT_VALGRIND/bin
623 GIT_VALGRIND_MODE="$valgrind"
624 export GIT_VALGRIND_MODE
625 GIT_VALGRIND_ENABLED=t
626 test -n "$valgrind_only" && GIT_VALGRIND_ENABLED=
627 export GIT_VALGRIND_ENABLED
628 elif test -n "$GIT_TEST_INSTALLED"
630 GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) ||
631 error "Cannot run git from $GIT_TEST_INSTALLED."
632 PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH
633 GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH}
634 else # normal case, use ../bin-wrappers only unless $with_dashes:
635 git_bin_dir="$GIT_BUILD_DIR/bin-wrappers"
636 if ! test -x "$git_bin_dir/git"
638 if test -z "$with_dashes"
640 say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH"
644 PATH="$git_bin_dir:$PATH"
645 GIT_EXEC_PATH=$GIT_BUILD_DIR
646 if test -n "$with_dashes"
648 PATH="$GIT_BUILD_DIR:$PATH"
651 GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt
653 GIT_CONFIG_NOSYSTEM=1
655 export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM
657 if test -z "$GIT_TEST_CMP"
659 if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT"
661 GIT_TEST_CMP="$DIFF -c"
663 GIT_TEST_CMP="$DIFF -u"
667 GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git
669 test -d "$GIT_BUILD_DIR"/templates/blt || {
670 error "You haven't built things yet, have you?"
673 if ! test -x "$GIT_BUILD_DIR"/test-chmtime
675 echo >&2 'You need to build test-chmtime:'
676 echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
681 TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)"
682 test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY"
683 case "$TRASH_DIRECTORY" in
684 /*) ;; # absolute path is good
685 *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;;
687 test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY
688 rm -fr "$TRASH_DIRECTORY" || {
690 echo >&5 "FATAL: Cannot prepare test area"
694 HOME="$TRASH_DIRECTORY"
697 if test -z "$TEST_NO_CREATE_REPO"
699 test_create_repo "$TRASH_DIRECTORY"
701 mkdir -p "$TRASH_DIRECTORY"
703 # Use -P to resolve symlinks in our working directory so that the cwd
704 # in subprocesses like git equals our $PWD (for pathname comparisons).
705 cd -P "$TRASH_DIRECTORY" || exit 1
708 this_test=${this_test%%-*}
709 if match_pattern_list "$this_test" $GIT_SKIP_TESTS
711 say_color info >&3 "skipping test $this_test altogether"
712 skip_all="skip all tests in $this_test"
716 # Provide an implementation of the 'yes' utility
731 # Fix some commands on Windows
734 # Windows has its own (incompatible) sort and find
744 # git sees Windows-style pwd
748 # no POSIX permissions
749 # backslashes in pathspec are converted to '/'
750 # exec does not inherit the PID
751 test_set_prereq MINGW
752 test_set_prereq NOT_CYGWIN
753 test_set_prereq SED_STRIPS_CR
754 test_set_prereq GREP_STRIPS_CR
755 GIT_TEST_CMP=mingw_test_cmp
758 test_set_prereq POSIXPERM
759 test_set_prereq EXECKEEPSPID
760 test_set_prereq NOT_MINGW
761 test_set_prereq CYGWIN
762 test_set_prereq SED_STRIPS_CR
763 test_set_prereq GREP_STRIPS_CR
766 test_set_prereq POSIXPERM
767 test_set_prereq BSLASHPSPEC
768 test_set_prereq EXECKEEPSPID
769 test_set_prereq NOT_MINGW
770 test_set_prereq NOT_CYGWIN
774 ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1
775 test -z "$NO_PERL" && test_set_prereq PERL
776 test -z "$NO_PYTHON" && test_set_prereq PYTHON
777 test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE
778 test -z "$NO_GETTEXT" && test_set_prereq GETTEXT
780 # Can we rely on git's output in the C locale?
781 if test -n "$GETTEXT_POISON"
783 GIT_GETTEXT_POISON=YesPlease
784 export GIT_GETTEXT_POISON
785 test_set_prereq GETTEXT_POISON
787 test_set_prereq C_LOCALE_OUTPUT
790 # Use this instead of test_cmp to compare files that contain expected and
791 # actual output from git commands that can be translated. When running
792 # under GETTEXT_POISON this pretends that the command produced expected
795 test -n "$GETTEXT_POISON" || test_cmp "$@"
798 # Use this instead of "grep expected-string actual" to see if the
799 # output from a git command that can be translated either contains an
800 # expected string, or does not contain an unwanted one. When running
801 # under GETTEXT_POISON this pretends that the command produced expected
804 if test -n "$GETTEXT_POISON"
807 elif test "x!" = "x$1"
816 test_lazy_prereq PIPE '
817 # test whether the filesystem supports FIFOs
823 rm -f testfifo && mkfifo testfifo
828 test_lazy_prereq SYMLINKS '
829 # test whether the filesystem supports symbolic links
830 ln -s x y && test -h y
833 test_lazy_prereq FILEMODE '
834 test "$(git config --bool core.filemode)" = true
837 test_lazy_prereq CASE_INSENSITIVE_FS '
838 echo good >CamelCase &&
839 echo bad >camelcase &&
840 test "$(cat CamelCase)" != good
843 test_lazy_prereq UTF8_NFD_TO_NFC '
844 # check whether FS converts nfd unicode to nfc
845 auml=$(printf "\303\244")
846 aumlcdiar=$(printf "\141\314\210")
856 test_lazy_prereq AUTOIDENT '
857 sane_unset GIT_AUTHOR_NAME &&
858 sane_unset GIT_AUTHOR_EMAIL &&
859 git var GIT_AUTHOR_IDENT
862 # When the tests are run as root, permission tests will report that
863 # things are writable when they shouldn't be.
864 test -w / || test_set_prereq SANITY
866 GIT_UNZIP=${GIT_UNZIP:-unzip}
867 test_lazy_prereq UNZIP '